import geopandas as gpd
import matplotlib.pyplot as plt

# Step 1: Read the GeoJSON file using GeoPandas
# https://en.wikipedia.org/wiki/GeoJSON
geojson_file = "sample.json"
gdf = gpd.read_file(geojson_file)

# Step 2: Create a plot using Matplotlib
fig, ax = plt.subplots(figsize=(10, 10))
gdf.plot(ax=ax)

# Step 3: Save the plot as a PNG file
output_png = "output.png"
plt.savefig(output_png, dpi=300, bbox_inches='tight')

# Step 4: Show the plot (optional)
plt.show()

# Step 5: Close the plot
plt.close()

